/*
 * Copyright (c) 2010 David McIntosh <dmcintosh@df12.net>
 *
 * Permission to use, copy, modify, and distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
 * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
 * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */

#import <AppKit/AppKit.h>
#import "util.h"
#import "GanttTask.h"

@interface GanttModel : NSObject <NSCoding>
{
    NSMutableArray *tasks;
    NSMutableDictionary *tasksDict;
}

-(GanttTask *)taskAtIndex:(NSUInteger)index;
-(GanttTask *)taskForTag:(NSInteger)tag;
-(void)addTask:(GanttTask *)aTask;
-(void)removeTaskWithTag:(NSInteger)tag;
-(void)addChild:(GanttTask *)task toTaskWithTag:(NSInteger)tag;
-(NSUInteger)count;
-(NSEnumerator *)rootTaskEnumerator;
-(NSDate *)earliestStartDate;
-(NSDate *)latestEndDate;

@end
